c     Copyright (C)
c     2000 -2013 Universite Paul Sabatier,
c     2000 -2013 Centre National de la Recherche Scientifique
c     2000 -2013 Ecole des Mines d'Albi
c     2014-2018 Msostar
c
c     This program is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 2, or (at your option)
c     any later version.

c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with this program; if not, write to the Free Software
c     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
c     USA.
c
      subroutine write_atmos_data(Nb,Nq)
      implicit none

      include 'max.inc'
      include 'data.inc'
      include 'files_out.inc'
      include 'formats.inc'

      integer Nb,Nq,i,j,band,quad
      integer t,res
      double precision dat
      

c     Looking for NaN values...
      t=0
      do band=1,Nb
         do i=1,m
            do quad=1,Nq
               dat=ka_gaz(band,i,quad)
               call test_nan(dat,res)
               if (res.eq.1) then
                  write(*,*) 'ka_gaz(',band,',',i,',',quad,')=',dat
                  t=1
                  goto 12345
               endif
               dat=kd_gaz(band,i,quad)
               call test_nan(dat,res)
               if (res.eq.1) then
                  write(*,*) 'kd_gaz(',band,',',i,',',quad,')=',dat
                  t=1
                  goto 12345
               endif
               dat=g_gaz(band,i,quad)
               call test_nan(dat,res)
               if (res.eq.1) then
                  write(*,*) 'g_gaz(',band,',',i,',',quad,')=',dat
                  t=1
                  goto 12345
               endif
            enddo ! quad

            dat=ka_aero(band,i,1)
            call test_nan(dat,res)
            if (res.eq.1) then
               write(*,*) 'ka_aero(',band,',',i,')=',dat
               t=1
               goto 12345
            endif
            dat=kd_aero(band,i,1)
            call test_nan(dat,res)
            if (res.eq.1) then
               write(*,*) 'kd_aero(',band,',',i,')=',dat
               t=1
               goto 12345
            endif
            dat=g_aero(band,i,1)
            call test_nan(dat,res)
            if (res.eq.1) then
               write(*,*) 'g_aero(',band,',',i,')=',dat
               t=1
               goto 12345
            endif
            
            dat=ka_cloud(band,i,1)
            call test_nan(dat,res)
            if (res.eq.1) then
               write(*,*) 'ka_cloud(',band,',',i,')=',dat
               t=1
               goto 12345
            endif
            dat=kd_cloud(band,i,1)
            call test_nan(dat,res)
            if (res.eq.1) then
               write(*,*) 'kd_cloud(',band,',',i,')=',dat
               t=1
               goto 12345
            endif
            dat=g_cloud(band,i,1)
            call test_nan(dat,res)
            if (res.eq.1) then
               write(*,*) 'g_cloud(',band,',',i,')=',dat
               t=1
               goto 12345
            endif
            
         enddo ! i
      enddo ! band

12345 continue
      if (t.eq.1) then
         call screen(1142,0,0,0.0D+0,0.0D+0)
         goto 666
      endif

c     Okay, now there are no NaNs in the new data. The only remaining
c     issue could be some zeroes that would crash the Monte-Carlo,
c     not speaking about dividing anything by zero while saving
c     the interpolated data file.
      call look_for_zeroes(Nb,Nq)

c     Here we go. Enjoy your new data file !
      call screen(35,0,0,0.0D+0,0.0D+0)
      open(10,file=file_interp)
      write(10,*) m,Nb,Nq!,nsj
      write(10,50) (alt(i),i=0,m-1)
      write(10,50) (e(i),i=0,m)
      write(10,50) (pres(i),i=0,m-1)
      write(10,50) (temp(i),i=0,m-1),Tsol,Tesp
      write(10,50) (dens(i),i=0,m-1)
      write(10,50) (adia(i),i=0,m-1)
      write(10,50) (grav(i),i=0,m-1)
      write(10,50) (zeta(i),i=0,m-1)
      write(10,50) (capa(i),i=0,m-1)
      do band=1,Nb
         write(10,50) lambda_lo(band),lambda_hi(band),
     &        em_sol(band),em_esp(band),
     &        (w_moy(band,quad),quad=1,Nq)
         do quad=1,Nq
            write(10,50) (ka_gaz(band,i,quad)+
     &           kd_gaz(band,i,quad),i=1,m)
            write(10,50) (ka_gaz(band,i,quad),i=1,m)
            write(10,50) (kd_gaz(band,i,quad),i=1,m)
            write(10,50) (kd_gaz(band,i,quad)/
     &           (ka_gaz(band,i,quad)+kd_gaz(band,i,quad)),i=1,m)
            write(10,50) (g_gaz(band,i,quad),i=1,m)
            write(10,50) (ka_aero(band,i,quad)+
     &           kd_aero(band,i,quad),i=1,m)
            write(10,50) (ka_aero(band,i,quad),i=1,m)
            write(10,50) (kd_aero(band,i,quad),i=1,m)
            write(10,50) (kd_aero(band,i,quad)/
     &           (ka_aero(band,i,quad)+kd_aero(band,i,quad)),i=1,m)
            write(10,50) (g_aero(band,i,quad),i=1,m)
            write(10,50) (ka_cloud(band,i,quad)+
     &           kd_cloud(band,i,quad),i=1,m)
            write(10,50) (ka_cloud(band,i,quad),i=1,m)
            write(10,50) (kd_cloud(band,i,quad),i=1,m)
            write(10,50) (kd_cloud(band,i,quad)/
     &           (ka_cloud(band,i,quad)+kd_cloud(band,i,quad)),i=1,m)
            write(10,50) (g_cloud(band,i,quad),i=1,m)
         enddo
      enddo
      close(10)

 666  continue
      return
      end
